<!DOCTYPE html>
<html>

<head>
    <title>INF226</title>
    <link rel="stylesheet" href="highlight.css" />
	<link rel="icon" href="favicon.png" type="image/png" />
    <style>
        * {
            box-sizing: border-box;
            ;
        }

        #page {
            height: 100vh;
            display: flex;
            flex-direction: column;
            ;
            padding: .5rem;
        }

        main {
            border-top: 1px solid grey;
            border-bottom: 1px solid grey;
            /* min-height: 50%; */
            flex-grow: 1;
            flex-shrink: 1;
            overflow:auto;
        }

        body {
            margin: 0;
        }

        label {
            justify-self: end;
            ;
        }

        #controls {
            /* min-height: 20%; */
            font-size: 1.4rem;
            display: grid;
            grid-template-columns: 1fr 6fr 1fr 1fr;
            grid-auto-rows: 1.4rem;
            ;
            grid-gap: .5rem;
            max-width: 70rem;

        }

        #messageDiv, #userDiv {
            border: 5px;
            border-style: double;
            border-color: black;
        }

        #output {
            width: 100%;
            height: 100%;
            background: #eee;
            overflow: auto;
            margin: 0;
        }
        #output p {
            border-bottom: 1px solid grey;
            padding-bottom: .25rem;
        }
        #header {
            display: flex;
            flex-direction: row;
            flex-wrap: wrap;
        }

        #textDiv {
            overflow-y: scroll;
            height: 400px;
        }

        #header li {
            display: block;
            font-style: italic;
            font-size: 1.2rem;
            padding: .25rem;
            margin:0 1rem;
        }
         /* Style the tab */
        .tab {
        overflow: hidden;
        border: 1px solid #ccc;
        background-color: #f1f1f1;
        }

        /* Style the buttons that are used to open the tab content */
        .tab button {
        background-color: inherit;
        float: left;
        border: none;
        outline: none;
        cursor: pointer;
        padding: 14px 16px;
        transition: 0.3s;
        }

        /* Change background color of buttons on hover */
        .tab button:hover {
        background-color: #ddd;
        }

        /* Create an active/current tablink class */
        .tab button.active {
        background-color: #ccc;
        }

        /* Style the tab content */
        .tabcontent {
        display: none;
        padding: 6px 12px;
        border: 1px solid #ccc;
        border-top: none;
        } 
    </style>

</head>

<body onload="set_current_user(),setup_friends()">
    <div id="page">
        <marquee>
            <div id="header"></div>
        </marquee>
        <!-- Tab links -->
        <div class="tab" id="friends">
        </div>
        <div id="friendContact"></div>
        <main>
            <pre id="output"></pre>
        </main>
        <div id="controls">
            <label for="search">Search:</label>
            <input type="search" id="search" name="search" enterkeyhint="search" value="*">
            <button type="button" id="searchBtn">Search!</button>
            <button type="button" id="allBtn">Show all</button>
            <label for="sender">From:</label>
            <input type="text" id="sender" name="sender" value="" readonly="true">

            <button type="button" id="sendBtn">Send</button>
            <button type="button" id="logoutBtn">Logout</button>
            <label for="reciver">To:</label>
            <input type="text" id="reciver" name="reciver" placeholder="Separate names with comma and space">
            <span></span>
            <span></span>
            
            <label for="message">Message:</label>
            <textarea id="message" style="grid-row: span 4;" placeholder="A message..."></textarea>
            
        </div>
        <div id="anchor"></div>
    </div>
</body>
<script>
    function showFriendInfo(evt, friendName) {
        if (friendName == "") {
            return;
        }
        // Declare all variables
        var i, tabcontent, tablinks;

        // Get all elements with class="tabcontent" and hide them
        tabcontent = document.getElementsByClassName("tabcontent");
        for (i = 0; i < tabcontent.length; i++) {
            tabcontent[i].style.display = "none";
        }

        // Get all elements with class="tablinks" and remove the class "active"
        tablinks = document.getElementsByClassName("tablinks");
        for (i = 0; i < tablinks.length; i++) {
            tablinks[i].className = tablinks[i].className.replace(" active", "");
        }

        // Show the current tab, and add an "active" class to the button that opened the tab
        const cTab = document.getElementById(friendName);
        cTab.style.display = "block";
        evt.currentTarget.className += " active";
        get_status(friendName).then(function (result) {
            for (let i = 0; i < cTab.childElementCount; i++) {
                let element = cTab.children[i];
                if (element.id == "status") {
                    element.textContent = "Status: " + result;
                }
            }
        });
    }

    var reqId = 0;
    var anchor = document.getElementById('anchor');
    var searchField = document.getElementById('search');
    var senderField = document.getElementById('sender');
    var reciverField = document.getElementById("reciver");
    var messageField = document.getElementById('message');
    var searchBtn = document.getElementById('searchBtn');
    var sendBtn = document.getElementById('sendBtn');
    var allBtn = document.getElementById('allBtn');
    var output = document.getElementById('output');
    var header = document.getElementById('header');
    var logoutBtn = document.getElementById('logoutBtn');
    var friendTab = document.getElementById("friends");
    var pageDiv = document.getElementById("page");
    var friendDiv = document.getElementById("friendContact");

    async function get_status(user) {
        return fetch(`/is_online?user=${encodeURIComponent(user)}`)
        .then(function (response) {
            return response.json();
        }).then(function (data) {
            return data.status;
        });
    }

    async function setup_friends() {
        fetch('/get_friends',  {method: 'GET'})
        .then(function (response) {
            return response.json();
        }).then(function (data) {
            const allUsers = document.createElement("button");
            allUsers.className = "tablinks";
            allUsers.textContent = "All Users";
            allUsers.addEventListener("click", () => showFriendInfo(event, "all_users"));

            // Content
            const users = document.createElement("div");
            users.className = "tabcontent"
            users.id = "all_users";  // Used to fetch content

            users.appendChild(get_online_users())

            users.appendChild(get_offline_users())
            

            friendTab.appendChild(allUsers);
            friendDiv.appendChild(users);

            const blocked = document.createElement("button");
            blocked.className = "tablinks";
            blocked.textContent = "Blocked Users";
            blocked.addEventListener("click", () => showFriendInfo(event, "blocked_users"));

            const bDiv = document.createElement("div");
            bDiv.className = "tabcontent";
            bDiv.id = "blocked_users"
            const bH3 = document.createElement("h3");
            bH3.textContent = "Blocked Users:"
            bDiv.appendChild(bH3);
            bDiv.appendChild(get_blocked_users());

            friendTab.appendChild(blocked);
            friendDiv.appendChild(bDiv);
            for (let i = 0; i < data.friends.length; i++) {
                const friend_info = data.friends[i];
                const f_name = friend_info.name;
                // Button
                const btn = document.createElement("button");
                btn.className = "tablinks";
                btn.textContent = f_name;
                btn.addEventListener("click", () => showFriendInfo(event, f_name));
                friendTab.appendChild(btn);

                // Content
                const div = document.createElement("div");
                div.className = "tabcontent"
                div.id = f_name;  // Used to fetch content

                const h3 = document.createElement("h3");
                const p = document.createElement("p");
                const p_1 = document.createElement("p");
                p_1.id = "status";
                h3.textContent = f_name;
                p.textContent = friend_info.fact;
                p_1.textContent = "Is online: " + friend_info.online;
                div.appendChild(h3);
                div.appendChild(p);
                div.appendChild(p_1);
                
                // Buttons
                const sendBtn = document.createElement("button");
                sendBtn.textContent = "Message";
                sendBtn.addEventListener("click", () => sendDm(f_name));
                div.appendChild(sendBtn);
                friendDiv.appendChild(div);
                
                const blockBtn = document.createElement("button");
                blockBtn.textContent = "Block";
                blockBtn.addEventListener("click", () => blockUser(f_name));
                div.appendChild(blockBtn);
                friendDiv.appendChild(div);


                // Text box
                const textDiv = setup_chatbox(f_name);
                textDiv.id = "textDiv";
                div.appendChild(textDiv);
            }
        });
    }

    // Returns a div with all blocked users
    function get_blocked_users() {
        const div = document.createElement("div");
        fetch(`/blocked_users`)
        .then(function (response) {
            return response.json();
        }).then(function (data) {
            data.users.forEach(user_data => {
                const mDiv = document.createElement("div");
                mDiv.id = "userDiv";
                const p = document.createElement("p");
                p.textContent = user_data.user;

                const blockBtn = document.createElement("button");
                blockBtn.textContent = "Unblock";
                blockBtn.addEventListener("click", () => unBlockUser(user_data.user));
                mDiv.appendChild(blockBtn);

                mDiv.appendChild(p);
                div.appendChild(mDiv);
            });
        });
        return div;
    }

    // Returns a div with all online users
    function get_online_users() {
        const div = document.createElement("div");
        const h3 = document.createElement("h3");
        h3.textContent = "Online"
        div.appendChild(h3);
        fetch("/online_users")
        .then(function (response) {
            return response.json();
        }).then(function (data) {
            data.users.forEach(user_data => {
                const mDiv = document.createElement("div");
                mDiv.id = "userDiv";
                const p = document.createElement("p");
                p.textContent = user_data.user;
                mDiv.appendChild(p);

                // Buttons
                const sendBtn = document.createElement("button");
                sendBtn.textContent = "Message";
                sendBtn.addEventListener("click", () => sendDm(user_data.user));
                mDiv.appendChild(sendBtn);
                
                const blockBtn = document.createElement("button");
                blockBtn.textContent = "Block";
                blockBtn.addEventListener("click", () => blockUser(user_data.user));
                mDiv.appendChild(blockBtn);

                const friendBtn = document.createElement("button");
                friendBtn.textContent = "Add Friend";
                friendBtn.addEventListener("click", () => add_friend(user_data.user));
                mDiv.appendChild(friendBtn);


                div.appendChild(mDiv);
            });
        });
        return div;
    }

    

    // Returns a div with all offline users
    function get_offline_users() {
        const div = document.createElement("div");
        const h3 = document.createElement("h3");
        h3.textContent = "Offline"
        div.appendChild(h3);
        fetch("/offline_users")
        .then(function (response) {
            return response.json();
        }).then(function (data) {
            data.users.forEach(user_data => {
                const mDiv = document.createElement("div");
                mDiv.id = "userDiv";
                const p = document.createElement("p");
                p.textContent = user_data.user;

                // Buttons
                const sendBtn = document.createElement("button");
                sendBtn.textContent = "Message";
                sendBtn.addEventListener("click", () => sendDm(user_data.user));
                mDiv.appendChild(sendBtn);
                
                const blockBtn = document.createElement("button");
                blockBtn.textContent = "Block";
                blockBtn.addEventListener("click", () => blockUser(user_data.user));
                mDiv.appendChild(blockBtn);

                const friendBtn = document.createElement("button");
                friendBtn.textContent = "Add Friend";
                friendBtn.addEventListener("click", () => add_friend(user_data.user));
                mDiv.appendChild(friendBtn);


                mDiv.appendChild(p);
                div.appendChild(mDiv);
            });
        });
        return div;
    }

    // Sets up the chatbox
    function setup_chatbox(user) {
        const div = document.createElement("div");
        const from_header = document.createElement("h3");
        div.appendChild(from_header);
        fetch(`/get_messages?user=${encodeURIComponent(user)}`)
        .then(function (response) {
            return response.json();
        }).then(function (data) {
            // TODO: Implement JSON stuff things
            // Assume its done :D and sorted C:
            from_header.textContent = data.from;
            data.messages.forEach(message => {
                const mDiv = document.createElement("div");
                mDiv.id = "messageDiv";
                const date = document.createElement("p");
                date.textContent = "Date: " + message.date;
                date.id = "messageDate";
                const time = document.createElement("p");
                time.textContent = "Time: " + message.time;
                time.id = "messageTime";
                const msg = document.createElement("p");
                msg.textContent = message.text;
                msg.id = "messageText";
                mDiv.appendChild(date);
                mDiv.appendChild(time);
                mDiv.appendChild(msg);
                div.appendChild(mDiv);
            });
        });
        return div;
    }

    async function sendDm(username) {
        //fetch(`/send_dm?reciver=${encodeURIComponent(username)}`, {method: 'POST'});
        const u = await get_current_user();
        location.assign(`/send_dm?reciver=${encodeURIComponent(username)}&sender=${encodeURIComponent(u)}`);
    }

    async function blockUser(username) {
        fetch(`/block_user?blocked_user=${encodeURIComponent(username)}`);
        clear_friends();
        await setTimeout(setup_friends, 1500);
    }

    async function add_friend(username) {
        fetch(`/add_friend?friend=${encodeURIComponent(username)}`);
        clear_friends();
        await setTimeout(setup_friends, 1500);
    }

    async function unBlockUser(username) {
        fetch(`/unblock_user?blocked_user=${encodeURIComponent(username)}`);
        clear_friends();
        await setTimeout(setup_friends, 1500);
    }

    function clear_output() {
        while (output.firstChild) {
            output.removeChild(output.firstChild);
        }
    }

    function clear_friends() {
        while (friendTab.firstChild) {
            friendTab.removeChild(friendTab.firstChild);
        }
        while (friendDiv.firstChild) {
            friendDiv.removeChild(friendDiv.firstChild);
        }
    }
    async function get_current_user() {
        return fetch('/test',  {method: 'GET'})
        .then(function (response) {
            return response.json();
        }).then(function (text) {
            return text.txt; 
        });
    }


    async function set_current_user() {
        fetch('/test',  {method: 'GET'})
        .then(function (response) {
            return response.json();
        }).then(function (text) {
            senderField.value = text.txt; 
        });
    }
    
    window.onbeforeunload = async function(){
        const q = '/logout';
        wait = await fetch(q);
    }

    var logout = async() => {
        const q = '/logout';
        wait = await fetch(q);
        document.location.reload();
    };

    logoutBtn.addEventListener('click', () => logout());


    var checkAnnouncements = async () => {
        res = await fetch('/announcements');
        anns = await res.json();
        if (anns && Array.isArray(anns.data)) {
            const elts = [];
            anns.data.forEach((element, idx) => {
                if (idx > 0) {
                    const node = document.createElement('li');
                    node.textContent = '  …  ';
                    elts.push(node);
                }
                const node = document.createElement('li');
                node.textContent = `${element.message || ''}`;
                elts.push(node);
            });
            console.log(elts);
            header.replaceChildren(...elts);
        }
    };
    var search = async (query) => {
        const id = reqId++;
        const q = `/search?q=${encodeURIComponent(query)}`;
        res = await fetch(q);
        console.log(res);
        const head = document.createElement('h3');
        head.textContent = "Messages including: " + query;
        output.appendChild(head);
        const body = document.createElement('p');
        body.innerHTML = await res.text();
        output.appendChild(body);
        body.scrollIntoView({block: "end", inline: "nearest", behavior: "smooth"});
        anchor.scrollIntoView();
        checkAnnouncements();
    };
    var send = async (sender, reciver, message) => {
        const id = reqId++;
        const q = `/send?sender=${encodeURIComponent(sender)}&message=${encodeURIComponent(message)}&reciver=${encodeURIComponent(reciver)}`;
        res = await fetch(q, { method: 'post' });
        console.log(res);
        const head = document.createElement('h3');
        head.textContent = "FROM: " + sender + " TO: " + reciver;
        output.appendChild(head);
        const body = document.createElement('p');
        body.innerHTML = await res.text();
        output.appendChild(body);
        body.scrollIntoView({block: "end", inline: "nearest", behavior: "smooth"});
        anchor.scrollIntoView();
        checkAnnouncements();
    };

    searchField.addEventListener('keydown', ev => {
        if (ev.key === 'Enter') {
            search(searchField.value);
        }
    });
    searchBtn.addEventListener('click', () => search(searchField.value));
    allBtn.addEventListener('click', () => search('*'));
    sendBtn.addEventListener('click', () => send(senderField.value, reciverField.value, messageField.value));
    checkAnnouncements();
</script>

</html>